;; -*- coding: utf-8 -*-
;;
;;   Copyright 2010-2015 Tuukka Turto
;;
;;   This file is part of pyherc.
;;
;;   pyherc is free software: you can redistribute it and/or modify
;;   it under the terms of the GNU General Public License as published by
;;   the Free Software Foundation, either version 3 of the License, or
;;   (at your option) any later version.
;;
;;   pyherc is distributed in the hope that it will be useful,
;;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;   GNU General Public License for more details.
;;
;;   You should have received a copy of the GNU General Public License
;;   along with pyherc.  If not, see <http://www.gnu.org/licenses/>.

(require pyherc.aspects)
(import [pyherc.aspects [log-debug log-info]]
        [pyherc.rules.metamorphosis.action [MetamorphosisAction]])

(defclass MetamorphosisFactory []
  [[--init-- #i(fn [self character-generator rng]
                 "default constructor"
                 (-> (super) (.--init--))
                 (setv self.character-generator character-generator)
                 (setv self.rng rng)
                 (setv self.action-type "metamorphosis")
                 nil)]
   [can-handle #d(fn [self parameters]
                   "can this factory handle a given action"
                   (= self.action-type parameters.action-type))]
   [get-action #d(fn [self parameters]
                   "create metamorphosis action"
                   (MetamorphosisAction parameters.character
                                        parameters.new-character-name
                                        self.character-generator
                                        self.rng
                                        parameters.destroyed-characters))]])
